import 'package:diameter/main.dart';
import 'package:diameter/models/bolus.dart';
import 'package:diameter/models/log_entry.dart';
import 'package:diameter/models/log_meal.dart';
import 'package:diameter/objectbox.g.dart';

@Entity(uid: 0)
class LogBolus {
  static final Box<LogBolus> box = objectBox.store.box<LogBolus>();

  int id;
  double units;
  double? carbs;
  int? delay;
  int? mgPerDl;
  double? mmolPerL;
  bool manuallyAdjusted;
  String? notes;

  final logEntry = ToOne<LogEntry>();
  final rate = ToOne<Bolus>();
  final meal = ToOne<LogMeal?>();

  LogBolus({
    this.id = 0,
    this.units = 0,
    this.carbs,
    this.delay,
    this.mgPerDl,
    this.mmolPerL,
    this.manuallyAdjusted = false,
    this.notes,
  });

  static LogBolus? get(int id) => box.get(id);
  static void put(LogBolus logBolus) => box.put(logBolus);
  static void remove(int id) => box.remove(id);
}
